<?php
  /*******************************************************
  			Add Meta Descriptions and canonical references 
  			By Joe Carver 
			Version 1.5 - 14 September 2010 
  *******************************************************/
  
    require_once('include/init.inc.php');
    if (!defined('IN_COPPERMINE')) {die('Not in Coppermine...');}
	global $CONFIG, $CPG_PHP_SELF, $template_header;
	
	// Add plugin_install action
	$thisplugin->add_action('plugin_install','add_meta_install');

	// Add plugin_uninstall action
	$thisplugin->add_action('plugin_uninstall','add_meta_uninstall');	
	
	function char_convert($str_a) {  // convert some characters if sanitized in db entry
	$str_a = str_replace(array('&amp;', '&quot;', '&lt;', '&gt;', '&#039;', '&#39;' , '_' , '-'), array('&', '"', '<', '>', "'", "'", '  ', '  ') ,$str_a);
	return  $str_a;
	}
	// grab category by supercage get
	$superCage = Inspekt::makeSuperCage();
	$now_cat = '';	
	if ($superCage->get->keyExists('cat')) {
	$now_cat = $superCage->get->getInt('cat');
	  }
	
	//  meta descrptions for category with albums
	if ($CPG_PHP_SELF == 'index.php' && $now_cat > 0) {  
    $thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	function add_meta_description($template_vars) {
	    global  $CONFIG, $LINEBREAK, $template_header, $meta, $CURRENT_CAT_NAME;
	// grab category by supercage get
	$superCage = Inspekt::makeSuperCage();		
 	if ($superCage->get->keyExists('cat')) {
	$now_cat = $superCage->get->getInt('cat');
	  }       
		$result = cpg_db_query("SELECT description FROM {$CONFIG['TABLE_CATEGORIES']} WHERE cid = '$now_cat'");
        $row = mysql_fetch_array($result);
        $this_cat = char_convert(strip_tags(bb_decode($row['description'])));
		mysql_free_result($result);

        $this_title = char_convert($CURRENT_CAT_NAME);
		
	    if ($this_cat != '')  {
	    $new_meta = <<< EOT
<meta name="description" content="$this_cat" /> 
EOT;
            } else  {
	        $new_meta = <<< EOT
<meta name="description" content="$this_title" /> 
EOT;
	    }
	
	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	
	}
    }
	
    // meta descrptions for albums
	if ($CPG_PHP_SELF == 'thumbnails.php') {
    $thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	function add_meta_description($template_vars) {	
        global $album, $aid, $LINEBREAK, $CONFIG, $template_header, $meta, $page, $lang_common;

	    $result = cpg_db_query("SELECT description, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid = '$album'");
        $row = mysql_fetch_array($result);
        $this_alb = strip_tags(bb_decode($row['description']));
        $this_title = char_convert(strip_tags(bb_decode($row['title'])));
		mysql_free_result($result);
	
	$meta_robo_array = array( // exclude meta albums list
    'lastup',
    'lastcom',
    'topn',
    'toprated',
    'favpics',
    'random',
    'datebrowse',
	'lastcomby',
	'lastupby',
	'lasthits',
	'search',
	'lastalb',
	'favpics'	
    );

	
	    if ($page > 0)  {
	$this_page_num = ' Page' . ' ' . $page . ' ';
	    } else  {
	        $this_page_num = '';
	    }
	
	    if ($this_alb != '')  {
	$alb_meta = <<< EOT
<meta name="description" content="$this_alb . $this_page_num" /> 
EOT;
        } else  {
	        $this_title = $this_title . ' ' . $lang_common['album'] . ' ' . $this_page_num . ' ';
	        $alb_meta = <<< EOT
<meta name="description" content="$this_title" /> 
EOT;
}
        $superCage = Inspekt::makeSuperCage();
        if (in_array($superCage->get->getAlpha('album'), $meta_robo_array)) {
	    $alb_meta = '';
	    } 

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $alb_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }

	//  meta descrptions for Home Page
	// determine page location - home or first album list page
	$superCage = Inspekt::makeSuperCage();
	if ($CPG_PHP_SELF == 'index.php' && !$superCage->get->keyExists('cat'))	{

	$thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta;
	
	$home_meta = char_convert($CONFIG['add_meta_home']);
    $new_meta = <<< EOT
<meta name="description" content="$home_meta" />
$LINEBREAK
EOT;

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }

	//  meta descrptions for main Album List Page	
	$superCage = Inspekt::makeSuperCage();
	if ($CPG_PHP_SELF == 'index.php' && $superCage->get->keyExists('cat') && $now_cat < 1)	{
	$thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta;

	    $alblist_meta = char_convert($CONFIG['add_meta_alblist']);	
        $new_meta = <<< EOT
<meta name="description" content="$alblist_meta" />
$LINEBREAK
EOT;

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }
    

	//  meta descrptions for Search Page		
	if ($CPG_PHP_SELF == 'search.php')	
	{
	    $thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	    function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta;

	    $search_meta = char_convert($CONFIG['add_meta_search']);	
        $new_meta = <<< EOT
<meta name="description" content="$search_meta" />
$LINEBREAK
EOT;

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }
	
	//  meta descrptions for Picture Page		
	if ($CPG_PHP_SELF == 'displayimage.php')	{
	$thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	
    function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta, $CURRENT_PIC_DATA, $lang_common, $CURRENT_ALBUM_DATA, $pic_pos;

		if ($CONFIG['add_meta_owner_name'] == 1)  {
		$pic_owner_number = $CURRENT_PIC_DATA['owner_id'];
		$result = cpg_db_query("SELECT user_name FROM {$CONFIG['TABLE_USERS']} WHERE user_id = '$pic_owner_number'");
        $row = mysql_fetch_array($result);
        $pic_owner_name = char_convert(strip_tags(bb_decode($row['user_name'])));
		mysql_free_result($result);	
        }	else  {
        $pic_owner_name = '';
        }		
				
		if ($CURRENT_PIC_DATA['caption'] != '') {
	    $pic_meta = char_convert(strip_tags(bb_decode($CURRENT_PIC_DATA['caption'])))  . '  ' . $pic_owner_name . ' ' . char_convert($CONFIG['add_meta_pics']);
        $new_meta = <<< EOT
<meta name="description" content="$pic_meta" /> 

EOT;
            } else  {
	        $home_meta = char_convert(strip_tags(bb_decode($CURRENT_PIC_DATA['title']))) . ' ' . $lang_common['album'] . ' ' . char_convert(strip_tags(bb_decode($CURRENT_ALBUM_DATA['title']))) . ' ' . char_convert(strip_tags(bb_decode($CURRENT_PIC_DATA['filename']))) . ' ' . $pic_owner_name . ' ' . char_convert($CONFIG['add_meta_pics']) . $pic_pos;
            $new_meta = <<< EOT
<meta name="description" content="$home_meta" />

EOT;
	}
	
	$meta_robo_array = array( // array to not list description, but to add link rel="canonical
    'lastup',
    'lastcom',
    'topn',
    'toprated',
    'favpics',
    'random',
    'datebrowse',
	'lastcomby',
	'lastupby',
	'lasthits',
	'search',
	'lastalb',
	'favpics'	
    );
		
    $superCage = Inspekt::makeSuperCage();
    if (in_array($superCage->get->getAlpha('album'), $meta_robo_array)) {
	$this_album  = $CURRENT_PIC_DATA['aid'];
	$this_file  = $CURRENT_PIC_DATA['pid'];
	
    if ($CONFIG['add_meta_pid'] == 1)  {	
	$this_pic  = <<< EOT
displayimage.php?pid=$this_file
EOT;
	
	}  else  {
	$this_pic  = <<< EOT
displayimage.php?album=$this_album&pid=$this_file
EOT;
    }

	$this_address = $CONFIG['site_url'];
	$this_canon = $this_address . $this_pic;
   $new_meta = <<< EOT
<link rel="canonical" href="$this_canon" />

EOT;
    } 	
	
	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	
    return array_merge($template_vars, $cat_meta);
	}
    }	
	
	//  meta descrptions for Contact Page		
	if ($CPG_PHP_SELF == 'contact.php')	
	{
	    $thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	    function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta;

	    $contact_meta = char_convert($CONFIG['add_meta_contact']);	
        $new_meta = <<< EOT
<meta name="description" content="$contact_meta" />
EOT;

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }	
	
	//  meta descrptions for Register Page		
	if ($CPG_PHP_SELF == 'register.php')	
	{
	    $thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	    function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta;

	    $register_meta = char_convert($CONFIG['add_meta_register']);	
        $new_meta = <<< EOT
<meta name="description" content="$register_meta" />
EOT;

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }	
	
	//  meta descrptions for Login Page		
	if ($CPG_PHP_SELF == 'login.php')	
	{
	    $thisplugin->add_filter('theme_pageheader_params','add_meta_description');	
	    function add_meta_description($template_vars) {
	    global $CONFIG, $LINEBREAK, $template_header, $meta;

	    $login_meta = char_convert($CONFIG['add_meta_login']);	
        $new_meta = <<< EOT
<meta name="description" content="$login_meta" />
EOT;

	$current_meta = $template_vars['{META}'];
	$cat_meta = array('{META}' => $current_meta . $new_meta);
	return array_merge($template_vars, $cat_meta);
	}
    }	
	
	
	// Install the plugin
	function add_meta_install() {
		global $CONFIG, $thisplugin;
		
		// add new meta to db
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_home', 'Home Page Coppermine Photo Gallery')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_alblist', 'Album List Main Page Coppermine Photo Gallery')");	
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_search', 'Search Page Coppermine Photo Gallery')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_pics', 'picture')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_owner_name', '1')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_contact', 'Contact the admin of this Coppermine Photo Gallery')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_register', 'Register an account on this Coppermine Photo Gallery')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_pid', '1')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('add_meta_login', 'Login to the gallery')");
		return true;
	}


	// Uninstall the plugin
	function add_meta_uninstall() {
		global $CONFIG, $thisplugin;
		
	//remove the record from config
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_home'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_alblist'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_search'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_pics'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_owner_name'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_contact'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_register'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_pid'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'add_meta_login'");
		return true;		
	}	
	
?>