<?php
  /*******************************************************
  			Add Meta Descriptions and canonical references 
  			By Joe Carver 
			Version 1.5 - 14 September 2010 
  *******************************************************/
  
if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}

// Define the default language array (English)
require_once ("./plugins/description_metas/lang/english.php");
// submit your lang file for this plugin on the coppermine forums
// plugin will try to use the configured language if it is available.
if (file_exists("./plugins/description_metas/lang/{$CONFIG['lang']}.php")) {
    require_once ("./plugins/description_metas/lang/{$CONFIG['lang']}.php");
} 

// Determine the help file link
if (file_exists("./plugins/description_metas/docs/{$CONFIG['lang']}.htm")) {
    $documentation_file = $CONFIG['lang'];
} else {
    $documentation_file = 'english';
}

$description_metas_icon_array['ok'] = cpg_fetch_icon('ok', 0);
$description_metas_icon_array['announcement'] = cpg_fetch_icon('announcement', 1);
$description_metas_icon_array['documentation'] = cpg_fetch_icon('documentation', 1);
$description_metas_icon_array['configure'] = cpg_fetch_icon('config', 1)
?>